package com.agiledeveloper

class PizzaShop
{
  private PizzaShop() {}

	public static int orderPizza(closure)
	{
	  def shop = new PizzaShop()

		// Allow user to work with PizzaShop
		closure(shop)
		
		// process order after user is done
		return 25 // obtain proper result
	}
	
  public PizzaShop ofSize(Size size) { return this; }
  public PizzaShop withCrust(Crust crust) { return this; }
  public PizzaShop withTopping(String topping) { return this; }
  public PizzaShop deliverToAddress(String address) { return this; }
  public PizzaShop chargingCard(CardType cardType, String cardNumber) { return this; }
}

time = PizzaShop.orderPizza { pizzaShop ->
	 pizzaShop.ofSize(Size.LARGE)
   .withCrust(Crust.THIN)
   .withTopping("Olives")
   .withTopping("Onions")
   .withTopping("Bell Pepper")
   .deliverToAddress("101 Main St., ...")
   .chargingCard(CardType.VISA, "1234-1234-1234-1234")
}
	
println "Pizza will be here in " + time + " minutes"